;--------------------------------------------------------------------------
;    interrupt.s - generic utility for MZ-800
;
;    Copyright (c) 2012 by Michal Hucik <http://www.ordoz.com>
;
;    Thies program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    driver_FDC is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with driver_FDC; if not, write to the Free Software
;    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
;--------------------------------------------------------------------------

	.module INTERRUPT

	.area _CODE

; INT vector musi byt ulozen na sudem adresnim bajtu !
_interrupt_vector::
	.db	0
	.dw	0

_interrupt_old_vector::
	.db	0
	.dw	0

_interrupt_install_isr::
	push ix
	ld ix, #0x0000 
        add ix, sp

	; Save old ISR vector
	ld hl, #_interrupt_vector
	ld de, #_interrupt_old_vector
	ld bc, #0x0003
	ldir

	; Mame vector na sude adrese?
	ld de, #_interrupt_vector
	bit 0, e
	jr z, 1$	; ano, je sudy
	inc de		; ne, zvysime ho
1$:
	push de
	pop iy		; do IY adresu vektoru

	di

	ld e, 4 (ix)	; parametr - adresa interrupt_code 
        ld d, 5 (ix)	;
        ld 0 (iy), e	; ulozime na adresu vektoru
        ld 1 (iy), d	;

	push iy
	pop hl

	ld a, l
        ld (#_interrupt_pioz80_data), a	; cast adresy vektoru do PIO
        ld a, h
        ld i, a				; cast adresy vektoru do 'I'

	ld hl, #_interrupt_pioz80_data
        ld bc, #0x06fc
        otir

	im 2
	ei

	pop ix
	ret

; inicializacni data pro z80pio
_interrupt_pioz80_data::
	.db	0x00		; dolni cast adresy int. vectoru (nulty bit musi
				; byt 0!)

	.db	0xff		; dolni 4 bity musi byt 1111, horni 2 pak
				; mod nasledujici operace 0 - out, 1 - in,
				; 2 - bidir, 3 - control

	.db	0x3f		; v modu 3 nastavujeme I/O - 1 bity rikaji,
				; ktere piny jsou vtupni, 0 - vystupni

	.db	0x97		; dolni 4 bity musi byt 0111, 7 - 1/0 En.INT/disable
				; 6 - 1/0 AND/OR, 5 - 1/0 Hi/Low, 4 - Mask
				; follows 0x97 = 1001 0111

	.db	0xdf		; protoze v predch. slove byl 4b = 1,
				; nasleduje bitova maska. Sledovany jsou jen
				; piny, jejihz bity jsou 0

	.db	0x83		; pri spodnich 0011, 7 bit povoluje/zakazuje
				; interrupt - (stejne jako u 0111)

_interrpt_uninstall_isr::
	; Restore old ISR vector
	push hl
	push de
	push bc
        di
	ld de, #_interrupt_vector
	ld hl, #_interrupt_old_vector
	ld bc, #0x0003
	ldir
        ei
	pop bc
	pop de
	pop hl
        ret
